
SET LOCAL search_path TO @extschema@;

CREATE TYPE pstamp_key;

CREATE FUNCTION pstamp_key_in_dummy(cstring)
  RETURNS pstamp_key
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_notimpl';

CREATE FUNCTION pstamp_key_out_dummy(pstamp_key)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_notimpl';

CREATE TYPE pstamp_key (
  internallength = 24,
  input = pstamp_key_in_dummy,
  output = pstamp_key_out_dummy,
  alignment = double );


CREATE TYPE pstamp;
CREATE TYPE pstamp_query;

CREATE FUNCTION pstamp_in(cstring)
  RETURNS pstamp
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_in';

CREATE FUNCTION pstamp_out(pstamp)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_out';

CREATE FUNCTION pstamp_recv(internal)
  RETURNS pstamp
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_recv';

CREATE FUNCTION pstamp_send(pstamp)
  RETURNS bytea
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_send';

CREATE FUNCTION pstamp_query_in(cstring)
  RETURNS pstamp_query
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_query_in';

CREATE FUNCTION pstamp_query_out(pstamp_query)
  RETURNS cstring
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_query_out';

CREATE TYPE pstamp (
  internallength = 12,
  input = pstamp_in,
  output = pstamp_out,
  receive = pstamp_recv,
  send = pstamp_send,
  alignment = double );

CREATE TYPE pstamp_query (
  internallength = VARIABLE,
  input = pstamp_query_in,
  output = pstamp_query_out,
  alignment = double,
  storage = external );


CREATE FUNCTION pstamp(int4, int8)
  RETURNS pstamp
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_new';

CREATE FUNCTION pstamp_query(int4[], int8 = NULL)
  RETURNS pstamp_query
  LANGUAGE C IMMUTABLE CALLED ON NULL INPUT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_query_new';

CREATE FUNCTION pstamp_query(int4, int8 = NULL)
  RETURNS pstamp_query
  LANGUAGE SQL IMMUTABLE CALLED ON NULL INPUT
  AS 'SELECT @extschema@.pstamp_query(ARRAY[$1], $2)';


CREATE FUNCTION pstamp_match_proc(pstamp, pstamp_query)
  RETURNS boolean
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_match';

CREATE OPERATOR <| (
  leftarg = pstamp,
  rightarg = pstamp_query,
  procedure = pstamp_match_proc,
  commutator = |>,
  restrict = eqsel,
  join = eqjoinsel
);

CREATE FUNCTION pstamp_match_commutator(pstamp_query, pstamp)
  RETURNS boolean
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<|) $1';

CREATE OPERATOR |> (
  leftarg = pstamp_query,
  rightarg = pstamp,
  procedure = pstamp_match_commutator,
  commutator = <|,
  restrict = eqsel,
  join = eqjoinsel
);

CREATE FUNCTION pstamp_distance_proc(pstamp, pstamp_query)
  RETURNS float8
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_pstamp_distance';

CREATE OPERATOR <-| (
  leftarg = pstamp,
  rightarg = pstamp_query,
  procedure = pstamp_distance_proc,
  commutator = |->
);

CREATE FUNCTION pstamp_distance_commutator(pstamp_query, pstamp)
  RETURNS float8
  LANGUAGE SQL IMMUTABLE
  AS 'SELECT $2 OPERATOR(@extschema@.<-|) $1';

CREATE OPERATOR |-> (
  leftarg = pstamp_query,
  rightarg = pstamp,
  procedure = pstamp_distance_commutator,
  commutator = <-|
);


CREATE FUNCTION cfl_gist_pstamp_consistent(internal)
  RETURNS internal
  LANGUAGE C IMMUTABLE STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_consistent';

CREATE FUNCTION cfl_gist_pstamp_union(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_union';

CREATE FUNCTION cfl_gist_pstamp_compress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_compress';

CREATE FUNCTION cfl_gist_decompress(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_decompress';

CREATE FUNCTION cfl_gist_pstamp_penalty(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_penalty';

CREATE FUNCTION cfl_gist_pstamp_picksplit(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_picksplit';

CREATE FUNCTION cfl_gist_pstamp_same(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_same';

CREATE FUNCTION cfl_gist_pstamp_distance(internal)
  RETURNS internal
  LANGUAGE C STRICT
  AS '$libdir/conflux-v0004', 'cfl_gist_pstamp_distance';

CREATE OPERATOR CLASS pstamp_ops
  DEFAULT FOR TYPE pstamp USING gist AS
  OPERATOR 1 <|  (pstamp, pstamp_query),
  OPERATOR 2 <-| (pstamp, pstamp_query) FOR ORDER BY float_ops,
  FUNCTION 1 cfl_gist_pstamp_consistent(internal),
  FUNCTION 2 cfl_gist_pstamp_union(internal),
  FUNCTION 3 cfl_gist_pstamp_compress(internal),
  FUNCTION 4 cfl_gist_decompress(internal),
  FUNCTION 5 cfl_gist_pstamp_penalty(internal),
  FUNCTION 6 cfl_gist_pstamp_picksplit(internal),
  FUNCTION 7 cfl_gist_pstamp_same(internal),
  FUNCTION 8 cfl_gist_pstamp_distance(internal),
  STORAGE pstamp_key;

